#SingleInstance FORCE
#NoTrayIcon

DetectHiddenText,On

TV1_W = 0.45 ; Ratio(0..1)
LV2_H = .7   ; Ratio(0..1)
GuiW  = 500
GUiH  = 450
KeyName = RButton Up
KeyNameJ = E{^
Menu_Invest0 = I
Menu_Invest1 = Jn

Gosub, Init
return

Init:
	Menu, GMenu, Add, %Menu_Invest1%, MenuInvestEvent
	Gui, +LastFound +Resize
	Gui, Menu, GMenu
	Gui, Margin, 0,0 
	Gui, Add, StatusBar, vSB1
	Gui, Add, TreeView,  vTV1 gTV1Event AltSubmit
	Gui, Add, ListView,  vLV2 Grid , name|value
	Gui, Add, ListView,  vLV1 gLV1Event -Multi, Treeid|hwnd|class
	Gui, ListView, LV1
	LV_ModifyCol(1,0)
	Gui, Show, w%GuiW% h%GuiH%
	return

GuiSize:
	GuiResize(A_GuiWidth, A_GuiHeight)
	return

GuiResize(guiW, guiH) {
	global TV1_W,LV2_H
	GuiControlGet, sb, POS, SB1
	GuiControl, Move, TV1, % "x" 0    " y" 0    " w" Round(guiW*TV1_W) " h" (guiH - sbH)
	GuiControlGet, pos, POS, TV1
	GuiControl, Move, LV2, % "x" posW " y" 0    " w" (guiW - posW)     " h" Round(posH*LV2_H)
	GuiControlGet, pos, POS, LV2
	GuiControl, Move, LV1, % "x" posX " y" posH " w" posW              " h" (guiH - posH -sbH)
}

GuiClose:
	ExitApp

GetWindowDetails:
	Hotkey, %A_ThisHotkey%, %A_ThisLabel%, Off
	Menu, GMenu, Rename, %Menu_Invest0%, %Menu_Invest1%
	MouseGetPos,,,hwnd
	DoInvest(hwnd)
	return

MenuInvestEvent:
	if (A_ThisMenuItem = Menu_Invest1) {
		SB_SetText(KeyNameJ "őΏۃEBhE")
		Hotkey, %KeyName%, GetWindowDetails, On
		Menu, %A_ThisMenu%, Rename, %A_ThisMenuItem%, %Menu_Invest0%
	} else {
		SB_SetText("𒆒f܂")
		Hotkey, %KeyName%, GetWindowDetails, Off
		Menu, %A_ThisMenu%, Rename, %A_ThisMenuItem%, %Menu_Invest1%
	}
	return

TV1Event:
	if (A_GuiEvent == "S")
		SelectListViewItemByTreeId(A_EventInfo)
	return

LV1Event:
	Gui, ListView, LV1
	if (A_GuiEvent == "I" && InStr(ErrorLevel, "S", true))
		SelectTreeViewItemByRowId(A_EventInfo)
	else if (A_GuiEvent = "DoubleClick") {
		ShowControlDetailsByRowId(A_EventInfo)
	}
	return

DoInvest(hwnd) {
	SetFormat, Integer, H
	Gui, TreeView, TV1
	Gui, ListView, LV1
	TV_Delete()
	LV_Delete()
	targetHwnd := hwnd
	rootId := AddItem(hwnd)
	WinGet, list, ControlListHwnd, ahk_id %hwnd%
	Loop, PARSE, list, `n
	{
		AddItem(A_LoopField)
	}
	LV_ModifyCol(1,0)
	Loop, 3
		LV_ModifyCol(1+A_Index, "AutoHdr")
	SetFormat, Integer, D
	SB_SetText(TV_GetCount() "/" LV_GetCount())
}

AddItem(cHwnd) {
	pId := 0, pHwnd := DllCall("GetParent", UInt,cHwnd, UInt)
	Loop, % LV_GetCount() 
	{
		LV_GetText(id,   A_Index, 1)
		LV_GetText(hwnd, A_Index, 2)
		if (hwnd == cHwnd)
			return false
		if (hwnd == pHwnd)
			pId := id
	}
	WinGetClass, name, ahk_id %cHwnd%
	id := TV_Add(name, pId, "Sort Expand")
	LV_Add("", id, cHwnd, name)
	return id
}

FindControlDetails(treeId, ByRef hwnd, ByRef className, ByRef ctrlName) {
	Gui, ListView, LV1
	Loop, % LV_GetCount() 
	{
		LV_GetText(id,   A_Index, 1)
		LV_GetText(hwnd, A_Index, 2)
		if (hwnd == cHwnd)
			return false
		if (hwnd == pHwnd)
			pId := id
	}
}

SelectListViewItemByTreeId(treeId) {
	Gui, ListView, LV1
	row := 0
	Loop, % LV_GetCount() 
	{
		LV_GetText(id,   A_Index, 1)
		if (id == treeId)
			row := A_Index
	}
	if (row)
		LV_Modify(row, "Select Focus Vis")
	ShowControlDetailsByRowId(row)
}

SelectTreeViewItemByRowId(row) {
	if (!row)
		return
	LV_GetText(treeId, row, 1)
	TV_Modify(treeId, "Select Vis Expand")
}

ShowControlDetailsByRowId(row) {
	LV_GetText(hwnd,    row, 2)
	ShowControlDetails(hwnd)
}


ShowControlDetails(hwnd) {
	Gui, ListView, LV2
	LV_Delete()
	IfWinNotExist, ahk_id %hwnd%
	{
		LV_Add("", "G[", "܂...")
		exit
	}
	names = hwnd|class|left|top|right|bottom|width|height
	WinGetClass ,class, ahk_id %hwnd%
	WinGetPos,left,top,width,height ,ahk_id %hwnd%
	right:=left+width, bottom:=top+height
	Loop, PARSE, names, |
		LV_Add("", A_LoopField, %A_LoopField%)
	types = SB_HORZ|SB_VERT|SB_CTRL
	names = Min,Max,Page,Pos,TrackPos
	SB_HORZ:=0,SB_VERT:=1,SB_CTRL:=2
	Loop, PARSE, types,|
	{
		dir:=A_LoopField
		ret := GetScrollInfoAll(hwnd, %dir%, nMin,nMax,nPage,nPos,nTrackPos)
		LV_Add("", dir, ret ? "true" : "false")
		Loop, PARSE, names, `,
			LV_Add("", dir "." A_LoopField, n%A_LoopField%)
		if (%A_LoopField% = SB_CTRL) {
			WinGet, style, Style, ahk_id %hwnd%
			LV_Add("", dir ".Vertical", ret ? ((style & 0x01) ? "ture" : "false") : "")
		}
	}
	Loop,2
		LV_ModifyCol(A_Index, "AutoHdr")
	return true
}

;
; type
;  SB_HORZ=0, SB_VERT=1, SB_CTRL=2
; see ttp://msdn.microsoft.com/ja-jp/library/cc364774.aspx
GetScrollInfoAll(hwnd, type, ByRef nMin="", ByRef nMax="", ByRef nPage="", ByRef nPos="", ByRef nTrackPos="") {
		VarSetCapacity(SCROLLINFO, 7*4, 0x00)
		NumPut(28,   SCROLLINFO, 0, "Int")
		NumPut(0x17, SCROLLINFO, 4, "Int") ; SIF_RANGE & SIF_PAGE & SIF_POS & SIF_TRACKPOS = 0x17
		nMin:="", nMax:="", nPage:="", nPos:="", nTrackPos:=""
		if (!DllCall("user32.dll\GetScrollInfo", UInt,hwnd, Int,type, Int,&SCROLLINFO, Bool))
			return false
		nMin := NumGet(SCROLLINFO, 8, "Int"), nMax := NumGet(SCROLLINFO, 12, "Int")
		, nPage := NumGet(SCROLLINFO, 16, "Int"), nPos := NumGet(SCROLLINFO, 20, "Int")
		, nTrackPos := NumGet(SCROLLINFO, 24, "Int")
		return true
}
